diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/he/he-ppdu.cc ns-3.45/src/wifi/model/he/he-ppdu.cc
--- ns-3.44/src/wifi/model/he/he-ppdu.cc	2025-03-09 16:55:49.791372500 -0700
+++ ns-3.45/src/wifi/model/he/he-ppdu.cc	2025-06-01 20:34:45.617702200 -0700
@@ -19,6 +19,7 @@
 #include "ns3/wifi-utils.h"
 
 #include <algorithm>
+#include <numeric>
 
 namespace ns3
 {
@@ -45,7 +46,8 @@
                const WifiPhyOperatingChannel& channel,
                Time ppduDuration,
                uint64_t uid,
-               TxPsdFlag flag)
+               TxPsdFlag flag,
+               bool instantiateHeaders /* = true */)
     : OfdmPpdu(psdus.begin()->second,
                txVector,
                channel,
@@ -53,20 +55,25 @@
                false), // don't instantiate LSigHeader of OfdmPpdu
       m_txPsdFlag(flag)
 {
-    NS_LOG_FUNCTION(this << psdus << txVector << channel << ppduDuration << uid << flag);
+    NS_LOG_FUNCTION(this << psdus << txVector << channel << ppduDuration << uid << flag
+                         << instantiateHeaders);
 
     // overwrite with map (since only first element used by OfdmPpdu)
     m_psdus.begin()->second = nullptr;
     m_psdus.clear();
     m_psdus = psdus;
-    SetPhyHeaders(txVector, ppduDuration);
+    if (instantiateHeaders)
+    {
+        SetPhyHeaders(txVector, ppduDuration);
+    }
 }
 
 HePpdu::HePpdu(Ptr<const WifiPsdu> psdu,
                const WifiTxVector& txVector,
                const WifiPhyOperatingChannel& channel,
                Time ppduDuration,
-               uint64_t uid)
+               uint64_t uid,
+               bool instantiateHeaders /* = true */)
     : OfdmPpdu(psdu,
                txVector,
                channel,
@@ -74,9 +81,13 @@
                false), // don't instantiate LSigHeader of OfdmPpdu
       m_txPsdFlag(PSD_NON_HE_PORTION)
 {
-    NS_LOG_FUNCTION(this << psdu << txVector << channel << ppduDuration << uid);
+    NS_LOG_FUNCTION(this << psdu << txVector << channel << ppduDuration << uid
+                         << instantiateHeaders);
     NS_ASSERT(!IsMu());
-    SetPhyHeaders(txVector, ppduDuration);
+    if (instantiateHeaders)
+    {
+        SetPhyHeaders(txVector, ppduDuration);
+    }
 }
 
 void
@@ -191,7 +202,9 @@
         txVector.SetGuardInterval(GetGuardIntervalFromEncoding(heSigHeader->m_giLtfSize));
         txVector.SetBssColor(heSigHeader->m_bssColor);
         SetHeMuUserInfos(txVector,
+                         WIFI_MOD_CLASS_HE,
                          heSigHeader->m_ruAllocation,
+                         heSigHeader->m_center26ToneRuIndication,
                          heSigHeader->m_contentChannels,
                          heSigHeader->m_sigBCompression,
                          GetMuMimoUsersFromEncoding(heSigHeader->m_muMimoUsers));
@@ -210,33 +223,99 @@
     }
 }
 
+WifiRu::RuSpec
+HePpdu::GetRuSpec(std::size_t ruAllocIndex, MHz_u bw, RuType ruType, std::size_t phyIndex) const
+{
+    auto isPrimary80{true};
+    auto index{phyIndex};
+    if (bw > MHz_u{80})
+    {
+        const auto isLow80 = ruAllocIndex < 4;
+        const auto p20Index = m_operatingChannel.GetPrimaryChannelIndex(MHz_u{20});
+        const auto primary80IsLower80 = (p20Index < bw / MHz_u{40});
+        if (!isLow80)
+        {
+            const auto numRusP80 = HeRu::GetRusOfType(MHz_u{80}, ruType).size();
+            index -= (ruType == RuType::RU_26_TONE) ? (numRusP80 - 1) : numRusP80;
+        }
+        isPrimary80 = ((primary80IsLower80 && isLow80) || (!primary80IsLower80 && !isLow80));
+    }
+    if ((ruType == RuType::RU_26_TONE) && (ruAllocIndex >= 2) && (index >= 19))
+    {
+        index++;
+    }
+    return HeRu::RuSpec{ruType, index, isPrimary80};
+}
+
 void
 HePpdu::SetHeMuUserInfos(WifiTxVector& txVector,
+                         WifiModulationClass mc,
                          const RuAllocation& ruAllocation,
+                         std::optional<Center26ToneRuIndication> center26ToneRuIndication,
                          const HeSigBContentChannels& contentChannels,
                          bool sigBcompression,
                          uint8_t numMuMimoUsers) const
 {
+    NS_ASSERT(ruAllocation.size() == Count20MHzSubchannels(txVector.GetChannelWidth()));
+    std::vector<uint8_t> remainingRuAllocIndices(ruAllocation.size());
+    std::iota(remainingRuAllocIndices.begin(), remainingRuAllocIndices.end(), 0);
     std::size_t contentChannelIndex = 0;
+    std::size_t ruAllocIndex = 0;
     for (const auto& contentChannel : contentChannels)
     {
         std::size_t numRusLeft = 0;
         std::size_t numUsersLeft = 0;
-        std::size_t ruAllocIndex = contentChannelIndex;
+        ruAllocIndex = remainingRuAllocIndices.front();
+        std::size_t numUsersLeftInCc = contentChannel.size();
+        if (contentChannel.empty())
+        {
+            const auto pos = std::find(remainingRuAllocIndices.cbegin(),
+                                       remainingRuAllocIndices.cend(),
+                                       ruAllocIndex);
+            remainingRuAllocIndices.erase(pos);
+            ++contentChannelIndex;
+            continue;
+        }
         for (const auto& userInfo : contentChannel)
         {
-            if (userInfo.staId == NO_USER_STA_ID)
+            if (center26ToneRuIndication && (numUsersLeftInCc == 1))
             {
-                continue;
+                // handle central 26 tones
+                if ((contentChannelIndex == 0) &&
+                    ((*center26ToneRuIndication ==
+                      Center26ToneRuIndication::CENTER_26_TONE_RU_LOW_80_MHZ_ALLOCATED) ||
+                     (*center26ToneRuIndication ==
+                      Center26ToneRuIndication::CENTER_26_TONE_RU_LOW_AND_HIGH_80_MHZ_ALLOCATED)))
+                {
+                    txVector.SetHeMuUserInfo(
+                        userInfo.staId,
+                        {HeRu::RuSpec{RuType::RU_26_TONE, 19, true}, userInfo.mcs, userInfo.nss});
+                    continue;
+                }
+                else if ((contentChannelIndex == 1) &&
+                         ((*center26ToneRuIndication ==
+                           Center26ToneRuIndication::CENTER_26_TONE_RU_HIGH_80_MHZ_ALLOCATED) ||
+                          (*center26ToneRuIndication ==
+                           Center26ToneRuIndication::
+                               CENTER_26_TONE_RU_LOW_AND_HIGH_80_MHZ_ALLOCATED)))
+                {
+                    txVector.SetHeMuUserInfo(
+                        userInfo.staId,
+                        {HeRu::RuSpec{RuType::RU_26_TONE, 19, false}, userInfo.mcs, userInfo.nss});
+                    continue;
+                }
             }
-            if (ruAllocIndex >= ruAllocation.size())
-            {
-                break;
-            }
-            auto ruSpecs = HeRu::GetRuSpecs(ruAllocation.at(ruAllocIndex));
-            if (ruSpecs.empty())
-            {
-                continue;
+            NS_ASSERT(ruAllocIndex < ruAllocation.size());
+            auto ruSpecs = WifiRu::GetRuSpecs(ruAllocation.at(ruAllocIndex), mc);
+            while (ruSpecs.empty() && (ruAllocIndex < ruAllocation.size()))
+            {
+                const auto pos = std::find(remainingRuAllocIndices.cbegin(),
+                                           remainingRuAllocIndices.cend(),
+                                           ruAllocIndex);
+                remainingRuAllocIndices.erase(pos);
+                ruAllocIndex += 2;
+                NS_ASSERT(ruAllocIndex < ruAllocation.size());
+                ruSpecs = WifiRu::GetRuSpecs(ruAllocation.at(ruAllocIndex), mc);
             }
             if (numRusLeft == 0)
             {
@@ -255,44 +334,41 @@
                 }
             }
             auto ruIndex = (ruSpecs.size() - numRusLeft);
-            auto ruSpec = ruSpecs.at(ruIndex);
-            auto ruType = ruSpec.GetRuType();
-            if ((ruAllocation.size() == 8) && (ruType == HeRu::RU_996_TONE) &&
-                (((txVector.GetChannelWidth() == MHz_u{160}) && sigBcompression) ||
-                 std::all_of(
-                     contentChannel.cbegin(),
-                     contentChannel.cend(),
-                     [&userInfo](const auto& item) { return userInfo.staId == item.staId; })))
-            {
-                ruType = HeRu::RU_2x996_TONE;
-            }
-            const auto ruBw = HeRu::GetBandwidth(ruType);
-            auto primary80 = ruAllocIndex < 4;
-            const uint8_t num20MhzSubchannelsInRu =
-                (ruBw < MHz_u{20}) ? 1 : Count20MHzSubchannels(ruBw);
-            auto numRuAllocsInContentChannel = std::max(1, num20MhzSubchannelsInRu / 2);
-            auto ruIndexOffset = (ruBw < MHz_u{20}) ? (ruSpecs.size() * ruAllocIndex)
-                                                    : (ruAllocIndex / num20MhzSubchannelsInRu);
-            if (!primary80)
+            const auto ruSpec = ruSpecs.at(ruIndex);
+            auto ruType = WifiRu::GetRuType(ruSpec);
+            if (sigBcompression)
             {
-                ruIndexOffset -= HeRu::GetRusOfType(MHz_u{80}, ruType).size();
+                ruType = WifiRu::GetRuType(ruAllocation.size() * MHz_u{20});
             }
-            if (!txVector.IsAllocated(userInfo.staId))
-            {
-                txVector.SetHeMuUserInfo(userInfo.staId,
-                                         {{ruType, ruSpec.GetIndex() + ruIndexOffset, primary80},
-                                          userInfo.mcs,
-                                          userInfo.nss});
-            }
-            if ((ruType == HeRu::RU_2x996_TONE) && !sigBcompression)
+            const auto ruBw = WifiRu::GetBandwidth(ruType);
+            const auto num20MhzSubchannelsInRu =
+                (ruBw < MHz_u{20}) ? 1 : Count20MHzSubchannels(ruBw);
+            if (userInfo.staId != NO_USER_STA_ID)
             {
-                return;
+                const std::size_t numRus =
+                    (ruBw > MHz_u{20}) ? 1 : HeRu::GetNRus(MHz_u{20}, ruType);
+                const std::size_t ruIndexOffset = (ruBw < MHz_u{20})
+                                                      ? (numRus * ruAllocIndex)
+                                                      : (ruAllocIndex / num20MhzSubchannelsInRu);
+                std::size_t phyIndex = WifiRu::GetIndex(ruSpecs.at(ruIndex)) + ruIndexOffset;
+                const auto ru{
+                    GetRuSpec(ruAllocIndex, txVector.GetChannelWidth(), ruType, phyIndex)};
+                txVector.SetHeMuUserInfo(userInfo.staId, {ru, userInfo.mcs, userInfo.nss});
             }
             numRusLeft--;
             numUsersLeft--;
+            numUsersLeftInCc--;
             if (numRusLeft == 0 && numUsersLeft == 0)
             {
-                ruAllocIndex += (2 * numRuAllocsInContentChannel);
+                const auto pos = std::find(remainingRuAllocIndices.cbegin(),
+                                           remainingRuAllocIndices.cend(),
+                                           ruAllocIndex);
+                remainingRuAllocIndices.erase(pos);
+                ruAllocIndex += num20MhzSubchannelsInRu;
+                if (ruAllocIndex % 2 != contentChannelIndex)
+                {
+                    ++ruAllocIndex;
+                }
             }
         }
         contentChannelIndex++;
@@ -410,11 +486,11 @@
         txVector.IsValid() && txVector.IsUlMu() && GetStaId() != SU_STA_ID)
     {
         TxPsdFlag flag = GetTxPsdFlag();
-        const auto ruWidth = HeRu::GetBandwidth(txVector.GetRu(GetStaId()).GetRuType());
+        const auto ruWidth = WifiRu::GetBandwidth(WifiRu::GetRuType(txVector.GetRu(GetStaId())));
         MHz_u channelWidth =
             (flag == PSD_NON_HE_PORTION && ruWidth < MHz_u{20}) ? MHz_u{20} : ruWidth;
-        NS_LOG_INFO("Use channelWidth=" << channelWidth << " MHz for HE TB from " << GetStaId()
-                                        << " for " << flag);
+        NS_LOG_INFO("Use " << channelWidth << " MHz for TB PPDU from " << GetStaId() << " for "
+                           << flag);
         return channelWidth;
     }
     else
@@ -468,15 +544,18 @@
         // Set dummy user info, PPDU will be dropped later after decoding PHY headers.
         m_txVector->SetHeMuUserInfo(
             staId,
-            {{HeRu::GetRuType(m_txVector->GetChannelWidth()), 1, true}, 0, 1});
+            {HeRu::RuSpec{(WifiRu::GetRuType(m_txVector->GetChannelWidth())), 1, true}, 0, 1});
     }
 }
 
 std::pair<std::size_t, std::size_t>
-HePpdu::GetNumRusPerHeSigBContentChannel(MHz_u channelWidth,
-                                         const RuAllocation& ruAllocation,
-                                         bool sigBCompression,
-                                         uint8_t numMuMimoUsers)
+HePpdu::GetNumRusPerHeSigBContentChannel(
+    MHz_u channelWidth,
+    WifiModulationClass mc,
+    const RuAllocation& ruAllocation,
+    std::optional<Center26ToneRuIndication> center26ToneRuIndication,
+    bool sigBCompression,
+    uint8_t numMuMimoUsers)
 {
     std::pair<std::size_t /* number of RUs in content channel 1 */,
               std::size_t /* number of RUs in content channel 2 */>
@@ -507,36 +586,76 @@
     switch (static_cast<uint16_t>(channelWidth))
     {
     case 40:
-        chSize.second += HeRu::GetRuSpecs(ruAllocation[1]).size();
+        chSize.second += WifiRu::GetRuSpecs(ruAllocation[1], mc).size();
         [[fallthrough]];
     case 20:
-        chSize.first += HeRu::GetRuSpecs(ruAllocation[0]).size();
+        chSize.first += WifiRu::GetRuSpecs(ruAllocation[0], mc).size();
         break;
     default:
         for (std::size_t n = 0; n < Count20MHzSubchannels(channelWidth);)
         {
-            chSize.first += HeRu::GetRuSpecs(ruAllocation[n]).size();
-            if (ruAllocation[n] >= 208)
+            std::size_t ccIndex;
+            const auto ruAlloc = ruAllocation.at(n);
+            std::size_t num20MHz{1};
+            const auto ruSpecs = WifiRu::GetRuSpecs(ruAlloc, mc);
+            const auto nRuSpecs = ruSpecs.size();
+            if (nRuSpecs == 1)
             {
-                // 996 tone RU occupies 80 MHz
-                n += 4;
-                continue;
+                const auto ruBw = WifiRu::GetBandwidth(WifiRu::GetRuType(ruSpecs.front()));
+                num20MHz = Count20MHzSubchannels(ruBw);
             }
-            n += 2;
-        }
-        for (std::size_t n = 0; n < Count20MHzSubchannels(channelWidth);)
-        {
-            chSize.second += HeRu::GetRuSpecs(ruAllocation[n + 1]).size();
-            if (ruAllocation[n + 1] >= 208)
+            if (nRuSpecs == 0)
             {
-                // 996 tone RU occupies 80 MHz
-                n += 4;
+                ++n;
                 continue;
             }
-            n += 2;
+            if (num20MHz > 1)
+            {
+                ccIndex = (chSize.first <= chSize.second) ? 0 : 1;
+            }
+            else
+            {
+                ccIndex = (n % 2 == 0) ? 0 : 1;
+            }
+            if (ccIndex == 0)
+            {
+                chSize.first += nRuSpecs;
+            }
+            else
+            {
+                chSize.second += nRuSpecs;
+            }
+            if (num20MHz > 1)
+            {
+                const auto skipNumIndices = (ccIndex == 0) ? num20MHz : num20MHz - 1;
+                n += skipNumIndices;
+            }
+            else
+            {
+                ++n;
+            }
         }
         break;
     }
+    if (center26ToneRuIndication)
+    {
+        switch (*center26ToneRuIndication)
+        {
+        case Center26ToneRuIndication::CENTER_26_TONE_RU_LOW_80_MHZ_ALLOCATED:
+            chSize.first++;
+            break;
+        case Center26ToneRuIndication::CENTER_26_TONE_RU_HIGH_80_MHZ_ALLOCATED:
+            chSize.second++;
+            break;
+        case Center26ToneRuIndication::CENTER_26_TONE_RU_LOW_AND_HIGH_80_MHZ_ALLOCATED:
+            chSize.first++;
+            chSize.second++;
+            break;
+        case Center26ToneRuIndication::CENTER_26_TONE_RU_UNALLOCATED:
+        default:
+            break;
+        }
+    }
     return chSize;
 }
 
@@ -551,29 +670,91 @@
         contentChannels.emplace_back();
     }
 
+    std::optional<HeSigBUserSpecificField> cc1Central26ToneRu;
+    std::optional<HeSigBUserSpecificField> cc2Central26ToneRu;
+
     const auto& orderedMap = txVector.GetUserInfoMapOrderedByRus(p20Index);
+    RuType prevRuType{RuType::RU_TYPE_MAX};
+    std::size_t prevRuIndex{0};
+    std::size_t prevCcIndex{0};
     for (const auto& [ru, staIds] : orderedMap)
     {
-        const auto ruType = ru.GetRuType();
-        if ((ruType > HeRu::RU_242_TONE) && !txVector.IsSigBCompression())
+        const auto ruType = WifiRu::GetRuType(ru);
+        auto ruIdx = WifiRu::GetIndex(ru);
+        if ((ruType == RuType::RU_26_TONE) && (ruIdx == 19))
         {
-            for (auto i = 0; i < ((ruType == HeRu::RU_2x996_TONE) ? 2 : 1); ++i)
+            NS_ASSERT(WifiRu::IsHe(ru));
+            const auto staId = *staIds.cbegin();
+            const auto& userInfo = txVector.GetHeMuUserInfo(staId);
+            if (std::get<HeRu::RuSpec>(ru).GetPrimary80MHz())
             {
-                for (auto staId : staIds)
-                {
-                    const auto& userInfo = txVector.GetHeMuUserInfo(staId);
-                    NS_ASSERT(ru == userInfo.ru);
-                    contentChannels[0].push_back({staId, userInfo.nss, userInfo.mcs});
-                    contentChannels[1].push_back({staId, userInfo.nss, userInfo.mcs});
-                }
+                NS_ASSERT(!cc1Central26ToneRu);
+                cc1Central26ToneRu = HeSigBUserSpecificField{staId, userInfo.nss, userInfo.mcs};
+            }
+            else
+            {
+                NS_ASSERT(!cc2Central26ToneRu);
+                cc2Central26ToneRu = HeSigBUserSpecificField{staId, userInfo.nss, userInfo.mcs};
+            }
+            continue;
+        }
+
+        const auto ruIndex = WifiRu::GetPhyIndex(ru, channelWidth, p20Index);
+        if ((prevRuType < RuType::RU_TYPE_MAX) && (prevRuType != ruType))
+        {
+            prevRuIndex *= WifiRu::GetBandwidth(prevRuType) / WifiRu::GetBandwidth(ruType);
+        }
+        if (ruType >= RuType::RU_484_TONE)
+        {
+            for (auto staId : staIds)
+            {
+                // equal split
+                const auto ccIndex =
+                    (contentChannels.at(0).size() <= contentChannels.at(1).size()) ? 0 : 1;
+                const auto& userInfo = txVector.GetHeMuUserInfo(staId);
+                NS_ASSERT(ru == userInfo.ru);
+                contentChannels[ccIndex].push_back({staId, userInfo.nss, userInfo.mcs});
             }
             continue;
         }
 
-        std::size_t numRus = (ruType >= HeRu::RU_242_TONE)
-                                 ? 1
-                                 : HeRu::m_heRuSubcarrierGroups.at({MHz_u{20}, ruType}).size();
-        const auto ruIdx = ru.GetIndex();
+        const auto mc = txVector.GetModulationClass();
+        const auto numRus = WifiRu::GetNRus(MHz_u{20}, ruType, mc);
+        while (prevRuIndex < ruIndex - 1)
+        {
+            std::size_t ccIndex{0};
+            if (channelWidth < MHz_u{40})
+            {
+                // only one content channel
+                ccIndex = 0;
+            }
+            else if (txVector.IsSigBCompression())
+            {
+                // equal split
+                ccIndex = (contentChannels.at(0).size() <= contentChannels.at(1).size()) ? 0 : 1;
+            }
+            else
+            {
+                ccIndex = ((prevRuIndex / numRus) % 2 == 0) ? 0 : 1;
+            }
+            const auto central26TonesRus =
+                WifiRu::GetCentral26TonesRus(channelWidth, prevRuType, mc);
+            const auto isCentral26ToneRu = std::none_of(
+                central26TonesRus.cbegin(),
+                central26TonesRus.cend(),
+                [ruIndex, channelWidth, p20Index](const auto& ruSpec) {
+                    return WifiRu::GetPhyIndex(ruSpec, channelWidth, p20Index) == ruIndex;
+                });
+            if (ruType < RuType::RU_242_TONE && prevCcIndex == ccIndex &&
+                (ruType != RuType::RU_26_TONE || isCentral26ToneRu))
+            {
+                contentChannels[ccIndex].push_back({NO_USER_STA_ID, 0, 0});
+            }
+            ++prevRuIndex;
+            prevCcIndex = ccIndex;
+        }
+        prevRuIndex = ruIndex;
+        prevRuType = ruType;
         for (auto staId : staIds)
         {
             const auto& userInfo = txVector.GetHeMuUserInfo(staId);
@@ -586,24 +767,46 @@
             }
             else if (txVector.IsSigBCompression())
             {
-                // equal split
+                // MU-MIMO: equal split
                 ccIndex = (contentChannels.at(0).size() <= contentChannels.at(1).size()) ? 0 : 1;
             }
-            else // MU-MIMO
+            else
             {
+                if (ruType == RuType::RU_26_TONE && ruIdx > 19)
+                {
+                    // "ignore" the center 26-tone RUs in 80 MHz channels
+                    ruIdx--;
+                    if (ruIdx > 37)
+                    {
+                        NS_ASSERT(!WifiRu::IsHe(ru));
+                        ruIdx -= (ruIdx - 19) / 37;
+                    }
+                }
                 ccIndex = (((ruIdx - 1) / numRus) % 2 == 0) ? 0 : 1;
             }
             contentChannels.at(ccIndex).push_back({staId, userInfo.nss, userInfo.mcs});
+            prevCcIndex = ccIndex;
         }
     }
 
+    if (cc1Central26ToneRu)
+    {
+        contentChannels.at(0).push_back(*cc1Central26ToneRu);
+    }
+    if (cc2Central26ToneRu)
+    {
+        contentChannels.at(1).push_back(*cc2Central26ToneRu);
+    }
+
     const auto isSigBCompression = txVector.IsSigBCompression();
     if (!isSigBCompression)
     {
         // Add unassigned RUs
         auto numNumRusPerHeSigBContentChannel = GetNumRusPerHeSigBContentChannel(
             channelWidth,
+            txVector.GetModulationClass(),
             txVector.GetRuAllocation(p20Index),
+            txVector.GetCenter26ToneRuIndication(),
             isSigBCompression,
             isSigBCompression ? txVector.GetHeMuUserInfoMap().size() : 0);
         std::size_t contentChannelIndex = 1;
@@ -627,7 +830,9 @@
 
 uint32_t
 HePpdu::GetSigBFieldSize(MHz_u channelWidth,
+                         WifiModulationClass mc,
                          const RuAllocation& ruAllocation,
+                         std::optional<Center26ToneRuIndication> center26ToneRuIndication,
                          bool sigBCompression,
                          std::size_t numMuMimoUsers)
 {
@@ -649,7 +854,9 @@
     }
 
     auto numRusPerContentChannel = GetNumRusPerHeSigBContentChannel(channelWidth,
+                                                                    mc,
                                                                     ruAllocation,
+                                                                    center26ToneRuIndication,
                                                                     sigBCompression,
                                                                     numMuMimoUsers);
     auto maxNumRusPerContentChannel =
